Index: /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.cpp	(revision 697)
@@ -24,4 +24,6 @@
 #include <string.h>
 
+#include <memory>
+
 
 // We declare an auto pointer to ccdsim.
@@ -133,13 +135,11 @@
     SetCCDParams(SimulatorSettingsN[0].value,SimulatorSettingsN[1].value,16,SimulatorSettingsN[2].value,SimulatorSettingsN[3].value);
     //  Kwiq
-    maxnoise=SimulatorSettingsN[10].value;
-    skyglow=SimulatorSettingsN[11].value;
+    maxnoise=SimulatorSettingsN[8].value;
+    skyglow=SimulatorSettingsN[9].value;
     maxval=SimulatorSettingsN[4].value;
     bias=SimulatorSettingsN[5].value;
     limitingmag=SimulatorSettingsN[7].value;
     saturationmag=SimulatorSettingsN[6].value;
-    focallength=SimulatorSettingsN[8].value;   //  focal length of the telescope in millimeters
-    OAGoffset=SimulatorSettingsN[12].value;    //  An oag is offset this much from center of scope position (arcminutes);
-    seeing=SimulatorSettingsN[9].value;        //  we get real fat stars in this one
+    OAGoffset=SimulatorSettingsN[10].value;    //  An oag is offset this much from center of scope position (arcminutes);
 
     nbuf = PrimaryCCD.getXRes() * PrimaryCCD.getYRes() * PrimaryCCD.getBPP();
@@ -154,5 +154,4 @@
 
     int nbuf;
-    SetupParms();
 
     if(HasGuideHead)
@@ -191,10 +190,8 @@
     IUFillNumber(&SimulatorSettingsN[6],"SIM_SATURATION","Saturation Mag","%4.1f",0,20,0,1.0);
     IUFillNumber(&SimulatorSettingsN[7],"SIM_LIMITINGMAG","Limiting Mag","%4.1f",0,20,0,20);
-    IUFillNumber(&SimulatorSettingsN[8],"SIM_FOCALLENGTH","Focal Length","%4.0f",0,60000,0,1000);
-    IUFillNumber(&SimulatorSettingsN[9],"SIM_FWHM","FWHM (arcseconds)","%4.2f",0,60,0,3.5);
-    IUFillNumber(&SimulatorSettingsN[10],"SIM_NOISE","CCD Noise","%4.0f",0,6000,0,50);
-    IUFillNumber(&SimulatorSettingsN[11],"SIM_SKYGLOW","Sky Glow (magnitudes)","%4.1f",0,6000,0,19.5);
-    IUFillNumber(&SimulatorSettingsN[12],"SIM_OAGOFFSET","Oag Offset (arminutes)","%4.1f",0,6000,0,0);
-    IUFillNumberVector(SimulatorSettingsNV,SimulatorSettingsN,13,deviceName(),"SIMULATOR_SETTINGS","Simulator Settings","Simulator Config",IP_RW,60,IPS_IDLE);
+    IUFillNumber(&SimulatorSettingsN[8],"SIM_NOISE","CCD Noise","%4.0f",0,6000,0,50);
+    IUFillNumber(&SimulatorSettingsN[9],"SIM_SKYGLOW","Sky Glow (magnitudes)","%4.1f",0,6000,0,19.5);
+    IUFillNumber(&SimulatorSettingsN[10],"SIM_OAGOFFSET","Oag Offset (arminutes)","%4.1f",0,6000,0,0);
+    IUFillNumberVector(SimulatorSettingsNV,SimulatorSettingsN,11,getDeviceName(),"SIMULATOR_SETTINGS","Simulator Settings","Simulator Config",IP_RW,60,IPS_IDLE);
 
 
@@ -202,8 +199,12 @@
     IUFillSwitch(&TimeFactorS[1],"10X","10x",ISS_OFF);
     IUFillSwitch(&TimeFactorS[2],"100X","100x",ISS_OFF);
-    IUFillSwitchVector(TimeFactorSV,TimeFactorS,3,deviceName(),"ON_TIME_FACTOR","Time Factor","Simulator Config",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-
-    //loadConfig();
+    IUFillSwitchVector(TimeFactorSV,TimeFactorS,3,getDeviceName(),"ON_TIME_FACTOR","Time Factor","Simulator Config",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    IUFillNumber(&FWHMN[0],"SIM_FWHM","FWHM (arcseconds)","%4.2f",0,60,0,7.5);
+    IUFillNumberVector(&FWHMNP,FWHMN,1,"Focuser Simulator", "FWHM","FWHM",OPTIONS_TAB,IP_RO,60,IPS_IDLE);
+
+    IUFillNumber(&ScopeParametersN[0],"TELESCOPE_APERTURE","Aperture (mm)","%g",50,4000,0,0.0);
+    IUFillNumber(&ScopeParametersN[1],"TELESCOPE_FOCAL_LENGTH","Focal Length (mm)","%g",100,10000,0,0.0 );
+    IUFillNumberVector(&ScopeParametersNP,ScopeParametersN,2,"Telescope Simulator","TELESCOPE_PARAMETERS","Scope Properties",OPTIONS_TAB,IP_RW,60,IPS_OK);
 
     return true;
@@ -219,7 +220,4 @@
     defineNumber(SimulatorSettingsNV);
     defineSwitch(TimeFactorSV);
-    //IDDefText(&ConfigFileTV, NULL);
-    //IDDefSwitch(&ConfigSaveRestoreSV, NULL);
-
 
     return;
@@ -231,4 +229,8 @@
 
     INDI::CCD::updateProperties();
+
+    if (isConnected())
+        SetupParms();
+
     return true;
 }
@@ -310,6 +312,4 @@
 
         PrimaryCCD.setExposure(timeleft);
-        //ImageExposureN[0].value = timeleft;
-        //IDSetNumber(ImageExposureNP, NULL);
 
         if(timeleft < 1.0)
@@ -567,10 +567,10 @@
             } else
             {
-                IDMessage(deviceName(),"Error looking up stars, is gsc installed with appropriate environment variables set ??");
+                IDMessage(getDeviceName(),"Error looking up stars, is gsc installed with appropriate environment variables set ??");
                 //fprintf(stderr,"Error doing gsc lookup\n");
             }
             if(drawn==0)
             {
-                IDMessage(deviceName(),"Got no stars, is gsc installed with appropriate environment variables set ??");
+                IDMessage(getDeviceName(),"Got no stars, is gsc installed with appropriate environment variables set ??");
 
             }
@@ -839,5 +839,5 @@
     //  first check if it's for our device
     //IDLog("INDI::CCD::ISNewNumber %s\n",name);
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         //  This is for our device
@@ -889,5 +889,5 @@
     //}
 
-    if(strcmp(dev,deviceName())==0) {
+    if(strcmp(dev,getDeviceName())==0) {
         //  This one is for us
 
@@ -924,2 +924,20 @@
 }
 
+bool CCDSim::ISSnoopDevice (XMLEle *root)
+{
+     if (IUSnoopNumber(root,&FWHMNP)==0)
+     {
+           seeing = FWHMNP.np[0].value;
+           IDLog("CCD Simulator: New FWHM value of %g\n", seeing);
+           return true;
+     }
+
+     if (IUSnoopNumber(root,&ScopeParametersNP)==0)
+     {
+           focallength = ScopeParametersNP.np[1].value;
+           IDLog("CCD Simulator: New focalLength value of %g\n", focallength);
+           return true;
+     }
+
+     return INDI::CCD::ISSnoopDevice(root);
+}
Index: /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h	(revision 697)
@@ -72,5 +72,5 @@
 
         INumberVectorProperty *SimulatorSettingsNV;
-        INumber SimulatorSettingsN[13];
+        INumber SimulatorSettingsN[11];
 
         ISwitch TimeFactorS[3];
@@ -78,4 +78,12 @@
 
         bool SetupParms();
+
+        //  We are going to snoop these from focuser
+        INumberVectorProperty FWHMNP;
+        INumber FWHMN[1];
+
+        // We are going to snoop these from telescope
+        INumber ScopeParametersN[2];
+        INumberVectorProperty ScopeParametersNP;
 
     public:
@@ -114,4 +122,5 @@
         virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
         virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+        virtual bool ISSnoopDevice (XMLEle *root);
 
 };
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp	(revision 697)
@@ -19,4 +19,5 @@
 #include "filter_simulator.h"
 
+#include <memory>
 
 // We declare an auto pointer to FilterSim.
@@ -99,5 +100,6 @@
     CurrentFilter=1;
     MinFilter=1;
-    MaxFilter=7;
+    MaxFilter=5;
+    FilterSlotN[0].max = MaxFilter;
     return true;
 }
@@ -119,2 +121,26 @@
     SelectFilterDone(CurrentFilter);
 }
+
+bool FilterSim::GetFilterNames(const char* groupName)
+{
+    char filterName[MAXINDINAME];
+    char filterLabel[MAXINDILABEL];
+
+    const char *filterDesignation[5] = { "Red", "Green", "Blue", "H Alpha", "Luminosity" };
+
+    if (FilterNameT != NULL)
+        delete FilterNameT;
+
+    FilterNameT = new IText[MaxFilter];
+
+    for (int i=0; i < MaxFilter; i++)
+    {
+        snprintf(filterName, MAXINDINAME, "FILTER_SLOT_NAME_%d", i+1);
+        snprintf(filterLabel, MAXINDILABEL, "Filter #%d", i+1);
+        IUFillText(&FilterNameT[i], filterName, filterLabel, filterDesignation[i]);
+    }
+
+    IUFillTextVector(FilterNameTP, FilterNameT, MaxFilter, getDeviceName(), "FILTER_NAME", "Filter", groupName, IP_RW, 0, IPS_IDLE);
+
+    return true;
+}
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h	(revision 697)
@@ -38,5 +38,5 @@
 
         virtual bool SetFilterNames() { return false; }
-        virtual bool GetFilterNames(const char *deviceName, const char* groupName) { return false; }
+        virtual bool GetFilterNames(const char* groupName);
 
 
Index: /BAORadio/libindi/libindi/drivers/focuser/robofocus.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/focuser/robofocus.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/focuser/robofocus.cpp	(revision 697)
@@ -26,4 +26,6 @@
 #include <string.h>
 #include <sys/time.h>
+#include <unistd.h>
+#include <memory>
 
 #define RF_MAX_CMD   9
@@ -102,5 +104,4 @@
  {
      ISInit();
-     roboFocus->ISSnoopDevice(root);
  }
 
@@ -127,10 +128,10 @@
     /* Port */
     IUFillText(&PortT[0], "PORT", "Port", "/dev/ttyUSB0");
-    IUFillTextVector(&PortTP, PortT, 1, deviceName(), "DEVICE_PORT", "Ports", MAIN_CONTROL_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillTextVector(&PortTP, PortT, 1, getDeviceName(), "DEVICE_PORT", "Ports", MAIN_CONTROL_TAB, IP_RW, 0, IPS_IDLE);
 
 
     /* Focuser temperature */
     IUFillNumber(&TemperatureN[0], "TEMPERATURE", "Celsius", "%6.2f", 0, 65000., 0., 10000.);
-    IUFillNumberVector(&TemperatureNP, TemperatureN, 1, deviceName(), "FOCUS_TEMPERATURE", "Temperature", MAIN_CONTROL_TAB, IP_RO, 0, IPS_IDLE);
+    IUFillNumberVector(&TemperatureNP, TemperatureN, 1, getDeviceName(), "FOCUS_TEMPERATURE", "Temperature", MAIN_CONTROL_TAB, IP_RO, 0, IPS_IDLE);
 
     /* Settings of the Robofocus */
@@ -138,5 +139,5 @@
     IUFillNumber(&SettingsN[1], "Step Delay", "Step delay", "%6.0f", 0., 255., 0., 1.0);
     IUFillNumber(&SettingsN[2], "Motor Steps", "Motor steps per tick", "%6.0f", 0., 255., 0., 1.0);
-    IUFillNumberVector(&SettingsNP, SettingsN, 3, deviceName(), "FOCUS_SETTINGS", "Settings", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillNumberVector(&SettingsNP, SettingsN, 3, getDeviceName(), "FOCUS_SETTINGS", "Settings", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
 
     /* Power Switches of the Robofocus */
@@ -145,33 +146,33 @@
     IUFillSwitch(&PowerSwitchesS[2], "3", "Switch 3", ISS_OFF);
     IUFillSwitch(&PowerSwitchesS[3], "4", "Switch 4", ISS_ON);
-    IUFillSwitchVector(&PowerSwitchesSP, PowerSwitchesS, 4, deviceName(), "SWTICHES", "Power", OPTIONS_TAB, IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
+    IUFillSwitchVector(&PowerSwitchesSP, PowerSwitchesS, 4, getDeviceName(), "SWTICHES", "Power", OPTIONS_TAB, IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
 
     /* Robofocus should stay within these limits */
     IUFillNumber(&MinMaxPositionN[0], "MINPOS", "Minimum Tick", "%6.0f", 1., 65000., 0., 100. );
     IUFillNumber(&MinMaxPositionN[1], "MAXPOS", "Maximum Tick", "%6.0f", 1., 65000., 0., 55000.);
-    IUFillNumberVector(&MinMaxPositionNP, MinMaxPositionN, 2, deviceName(), "FOCUS_MINMAXPOSITION", "Extrama", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillNumberVector(&MinMaxPositionNP, MinMaxPositionN, 2, getDeviceName(), "FOCUS_MINMAXPOSITION", "Extrama", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
 
     IUFillNumber(&MaxTravelN[0], "MAXTRAVEL", "Maximum travel", "%6.0f", 1., 64000., 0., 10000.);
-    IUFillNumberVector(&MaxTravelNP, MaxTravelN, 1, deviceName(), "FOCUS_MAXTRAVEL", "Max. travel", OPTIONS_TAB, IP_RW, 0, IPS_IDLE );
+    IUFillNumberVector(&MaxTravelNP, MaxTravelN, 1, getDeviceName(), "FOCUS_MAXTRAVEL", "Max. travel", OPTIONS_TAB, IP_RW, 0, IPS_IDLE );
 
     /* Set Robofocus position register to the this position */
     IUFillNumber(&SetRegisterPositionN[0], "SETPOS", "Position", "%6.0f", 0, 64000., 0., 0. );
-    IUFillNumberVector(&SetRegisterPositionNP, SetRegisterPositionN, 1, deviceName(), "FOCUS_REGISTERPOSITION", "Set register", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillNumberVector(&SetRegisterPositionNP, SetRegisterPositionN, 1, getDeviceName(), "FOCUS_REGISTERPOSITION", "Set register", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
 
     /* Backlash */
     IUFillNumber(&SetBacklashN[0], "SETBACKLASH", "Backlash", "%6.0f", -255., 255., 0., 0.);
-    IUFillNumberVector(&SetBacklashNP, SetBacklashN, 1, deviceName(), "FOCUS_BACKLASH", "Set Register", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillNumberVector(&SetBacklashNP, SetBacklashN, 1, getDeviceName(), "FOCUS_BACKLASH", "Set Register", OPTIONS_TAB, IP_RW, 0, IPS_IDLE);
 
     /* Robofocus` position (RO) */
     IUFillNumber(&PositionN[0], "POSITION", "Tick", "%6.0f", 0, 65000., 0., 10000.);
-    IUFillNumberVector(&PositionNP, PositionN, 1, deviceName(), "FOCUS_POSITION", "Position", MAIN_CONTROL_TAB, IP_RO, 0, IPS_IDLE);
+    IUFillNumberVector(&PositionNP, PositionN, 1, getDeviceName(), "FOCUS_POSITION", "Position", MAIN_CONTROL_TAB, IP_RO, 0, IPS_IDLE);
 
 
     /* Relative and absolute movement */
     IUFillNumber(&RelMovementN[0], "RELMOVEMENT", "Ticks", "%6.0f", -65000., 65000., 0., 100. );
-    IUFillNumberVector(&RelMovementNP, RelMovementN, 1, deviceName(), "FOCUS_RELMOVEMENT", "Relative GoTo", MAIN_CONTROL_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillNumberVector(&RelMovementNP, RelMovementN, 1, getDeviceName(), "FOCUS_RELMOVEMENT", "Relative GoTo", MAIN_CONTROL_TAB, IP_RW, 0, IPS_IDLE);
 
     IUFillNumber(&AbsMovementN[0], "ABSMOVEMENT", "Tick", "%6.0f", 0, 65000., 0., 10000.);
-    IUFillNumberVector(&AbsMovementNP, AbsMovementN, 1, deviceName(), "FOCUS_ABSMOVEMENT", "Absolute GoTo", MAIN_CONTROL_TAB, IP_RW, 0, IPS_IDLE);
+    IUFillNumberVector(&AbsMovementNP, AbsMovementN, 1, getDeviceName(), "FOCUS_ABSMOVEMENT", "Absolute GoTo", MAIN_CONTROL_TAB, IP_RW, 0, IPS_IDLE);
 
 
@@ -245,5 +246,5 @@
             IDLog("Failed to connect o port %s. Error: %s", PortT[0].text, errorMsg);
 
-        IDMessage(deviceName(), "Failed to connect to port %s. Error: %s", PortT[0].text, errorMsg);
+        IDMessage(getDeviceName(), "Failed to connect to port %s. Error: %s", PortT[0].text, errorMsg);
 
         return false;
@@ -254,13 +255,13 @@
     {
       /* This would be the end*/
-        IDMessage( deviceName(), "Unknown error while reading Robofocus firmware\n");
+        IDMessage( getDeviceName(), "Unknown error while reading Robofocus firmware\n");
         return false;
     }
 
-    IDMessage(deviceName(), "Robofocus is online. Getting focus parameters...");
+    IDMessage(getDeviceName(), "Robofocus is online. Getting focus parameters...");
 
     GetFocusParams();
 
-    IDMessage(deviceName(), "RoboFocus paramaters readout complete, focuser ready for use.");
+    IDMessage(getDeviceName(), "RoboFocus paramaters readout complete, focuser ready for use.");
 
     return true;
@@ -270,5 +271,5 @@
 {
     tty_disconnect(PortFD);
-    IDMessage(deviceName(), "RoboFocus is offline.");
+    IDMessage(getDeviceName(), "RoboFocus is offline.");
     return true;
 }
@@ -390,5 +391,5 @@
               {
                   IDLog("TTY error detected: %s\n", robofocus_error);
-                  IDMessage(deviceName(), "TTY error detected: %s\n", robofocus_error);
+                  IDMessage(getDeviceName(), "TTY error detected: %s\n", robofocus_error);
               }
               return false;
@@ -848,5 +849,5 @@
 bool RoboFocus::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
 {
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         // ===================================
@@ -870,5 +871,5 @@
 bool RoboFocus::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
 {
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
         if (!strcmp (name, PowerSwitchesSP.name))
@@ -951,5 +952,5 @@
     int nset=0,i=0;
 
-    if(strcmp(dev,deviceName())==0)
+    if(strcmp(dev,getDeviceName())==0)
     {
 
@@ -1086,5 +1087,5 @@
                 IDSetNumber(&PositionNP, "Robofocus position recovered %5.0f", currentPosition);
 
-                IDMessage( deviceName(), "Robofocus position recovered resuming normal operation");
+                IDMessage( getDeviceName(), "Robofocus position recovered resuming normal operation");
 
                 /* We have to leave here, because new_rpos is not set */
@@ -1170,5 +1171,5 @@
                 PositionNP.s = IPS_OK;
                 IDSetNumber(&PositionNP, "Robofocus position recovered %5.0f", currentPosition);
-                IDMessage( deviceName(), "Robofocus position recovered resuming normal operation");
+                IDMessage( getDeviceName(), "Robofocus position recovered resuming normal operation");
                 /* We have to leave here, because new_apos is not set */
                 return false;
@@ -1405,5 +1406,5 @@
                 PositionNP.s = IPS_OK;
                 IDSetNumber(&PositionNP, "Robofocus position recovered %5.0f", currentPosition);
-                IDMessage( deviceName(), "Robofocus position recovered resuming normal operation");
+                IDMessage( getDeviceName(), "Robofocus position recovered resuming normal operation");
                 /* We have to leave here, because new_apos is not set */
                 return true ;
Index: /BAORadio/libindi/libindi/drivers/focuser/tcfs.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/focuser/tcfs.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/focuser/tcfs.cpp	(revision 697)
@@ -156,5 +156,5 @@
     static int propInit=0;
 
-    INDI::DefaultDriver::ISGetProperties(dev);
+    INDI::DefaultDevice::ISGetProperties(dev);
 
     if (propInit == 0)
@@ -239,5 +239,5 @@
     if (tty_connect(tProp->tp[0].text, 19200, 8, 0, 1, &fd) != TTY_OK)
     {
-        IDMessage(deviceName(), "Error connecting to port %s. Make sure you have BOTH read and write permission to the port.", tProp->tp[0].text);
+        IDMessage(getDeviceName(), "Error connecting to port %s. Make sure you have BOTH read and write permission to the port.", tProp->tp[0].text);
 	return false;
     }
@@ -251,5 +251,5 @@
             if (!strcmp(response, "!"))
             {
-                IDMessage(deviceName(), "Successfully connected to TCF-S Focuser in Manual Mode.");
+                IDMessage(getDeviceName(), "Successfully connected to TCF-S Focuser in Manual Mode.");
 
                 IUResetSwitch(FocusModeSP);
@@ -274,5 +274,5 @@
     }
 
-    IDMessage(deviceName(), "Error connecting to TCF-S focuser...");
+    IDMessage(getDeviceName(), "Error connecting to TCF-S focuser...");
     return false;
 
@@ -316,5 +316,5 @@
   {
       resetProperties();
-      IDMessage(deviceName(), "TCF-S is offline. Connect before issiung any commands.");
+      IDMessage(getDeviceName(), "TCF-S is offline. Connect before issiung any commands.");
       return false;
   }
@@ -355,5 +355,5 @@
   }
 
-  return DefaultDriver::ISNewNumber (dev, name, values, names, n);
+  return DefaultDevice::ISNewNumber (dev, name, values, names, n);
     
 }
@@ -383,5 +383,5 @@
 
 
-    return DefaultDriver::ISNewText(dev, name, texts, names, n);
+    return DefaultDevice::ISNewText(dev, name, texts, names, n);
 	
 }
@@ -396,5 +396,5 @@
     ISwitch *current_active_switch = NULL, *target_active_switch = NULL;
     // First process parent!
-    if (INDI::DefaultDriver::ISNewSwitch(deviceName(), name, states, names, n) == true)
+    if (INDI::DefaultDevice::ISNewSwitch(getDeviceName(), name, states, names, n) == true)
         return true;
 
@@ -417,5 +417,5 @@
     {
       resetProperties();
-      IDMessage(deviceName(), "TCF-S is offline. Connect before issiung any commands.");
+      IDMessage(getDeviceName(), "TCF-S is offline. Connect before issiung any commands.");
       return false;
     }
@@ -664,5 +664,5 @@
 
 
-    return DefaultDriver::ISNewSwitch(dev, name, states, names, n);
+    return DefaultDevice::ISNewSwitch(dev, name, states, names, n);
 }
 
Index: /BAORadio/libindi/libindi/drivers/focuser/tcfs.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/focuser/tcfs.h	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/focuser/tcfs.h	(revision 697)
@@ -27,5 +27,5 @@
 #include <indidevapi.h>
 #include <indicom.h>
-#include <indibase/defaultdriver.h>
+#include <indibase/defaultdevice.h>
 
 using namespace std;
@@ -35,5 +35,5 @@
 #define TCFS_ERROR_BUFFER   1024
 
-class TCFS : public INDI::DefaultDriver
+class TCFS : public INDI::DefaultDevice
 {
 
Index: /BAORadio/libindi/libindi/drivers/telescope/BAO.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/BAO.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/BAO.cpp	(revision 697)
@@ -652,45 +652,51 @@
             else if (chaine[0] == 'M')
             {
-                IDSetText(&CommandTP, "Calcul des matrices de correction\n" );
-
-                if  (Sockets[targetAlignmentIP].AlignementAntenne->nbrcorrections >=3 )
+                if (targetAlignmentIP != -1)
                 {
-                    Sockets[targetAlignmentIP].AlignementAntenne->AlignementEnCours = 0;
-		    
-		    Sockets[targetAlignmentIP].AlignementAntenne->InitParametresInstrument();
-		    
-                    Sockets[targetAlignmentIP].AlignementAntenne->CalculerMatriceCorrection(targetRA, targetDEC);
-		    
-		     Sockets[targetAlignmentIP].AlignementAntenne->EnregistrementParametresAlignement(
+                    IDSetText(&CommandTP, "Calcul des matrices de correction\n" );
+
+                    if  (Sockets[targetAlignmentIP].AlignementAntenne->nbrcorrections >=3 )
+                    {
+                        Sockets[targetAlignmentIP].AlignementAntenne->AlignementEnCours = 0;
+
+                        Sockets[targetAlignmentIP].AlignementAntenne->InitParametresInstrument();
+
+                        Sockets[targetAlignmentIP].AlignementAntenne->CalculerMatriceCorrection(targetRA, targetDEC);
+
+                        Sockets[targetAlignmentIP].AlignementAntenne->EnregistrementParametresAlignement(
+                            Sockets[targetAlignmentIP].IP,
+                            "/home/" + (string)getenv("USER") + "/AlignementAntennes.cfg");
+                    }
+                    else
+                    {
+                        Sockets[targetAlignmentIP].AlignementAntenne->Identity();
+
+                        Sockets[targetAlignmentIP].AlignementAntenne->Matrice_ok = false;
+                    }
+                }
+            }
+            else if (chaine[0] == 'R')
+            {
+                if (targetAlignmentIP != -1)
+                {
+                    IDSetText(&CommandTP, "Reinitialisation de la matrice de correction\n" );
+
+                    Sockets[targetAlignmentIP].AlignementAntenne->InitParametresInstrument();
+
+                    Sockets[targetAlignmentIP].AlignementAntenne->Identity();
+
+                    Sockets[targetAlignmentIP].AlignementAntenne->Matrice_ok = false;
+
+                    Sockets[targetAlignmentIP].AlignementAntenne->EnregistrementParametresAlignement(
                         Sockets[targetAlignmentIP].IP,
                         "/home/" + (string)getenv("USER") + "/AlignementAntennes.cfg");
                 }
-                else
-                {
-                    Sockets[targetAlignmentIP].AlignementAntenne->Identity();
-
-                    Sockets[targetAlignmentIP].AlignementAntenne->Matrice_ok = false;
-                }
-            }
-            else if (chaine[0] == 'R')
-            {
-                IDSetText(&CommandTP, "Reinitialisation de la matrice de correction\n" );
-
-                 Sockets[targetAlignmentIP].AlignementAntenne->InitParametresInstrument();
-		 
-		 Sockets[targetAlignmentIP].AlignementAntenne->Identity();
-
-                Sockets[targetAlignmentIP].AlignementAntenne->Matrice_ok = false;
-		
-		 Sockets[targetAlignmentIP].AlignementAntenne->EnregistrementParametresAlignement(
-                        Sockets[targetAlignmentIP].IP,
-                        "/home/" + (string)getenv("USER") + "/AlignementAntennes.cfg");
-	    }
+            }
             else if (chaine[0] == 'O')
             {
-                IDSetText(&CommandTP, "Optimisation de la geometrie de l antenne\n" );
-
                 if (targetAlignmentIP != -1)
                 {
+                    IDSetText(&CommandTP, "Optimisation de la geometrie de l antenne\n" );
+
                     Sockets[targetAlignmentIP].AlignementAntenne->OptimisationGeometrieAntenne(true);
 
@@ -1798,5 +1804,5 @@
 
                     double az, ha, ad, de;
-		    
+
                     int num = Sockets[i].AlignementAntenne->nbrcorrections;
 
Index: /BAORadio/libindi/libindi/drivers/telescope/celestrongps.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/celestrongps.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/celestrongps.cpp	(revision 697)
@@ -447,4 +447,6 @@
 	  
 	  if (IUUpdateSwitch(&OnCoordSetSP, states, names, n) < 0) return;
+          OnCoordSetSP.s = IPS_OK;
+          IDSetSwitch(&OnCoordSetSP, NULL);
 	  currentSet = getOnSwitch(&OnCoordSetSP);
 	}
@@ -524,7 +526,5 @@
 	 last_move = getOnSwitch(&MovementNSSP);
 
-	 if (IUUpdateSwitch(&MovementNSSP, states, names, n) < 0)
-        IDLog("fixme!!! - IUUpdateSwitch MovementNSSP\n");
-	//	return;
+         IUUpdateSwitch(&MovementNSSP, states, names, n);
 
 	current_move = getOnSwitch(&MovementNSSP);
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200basic.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200basic.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200basic.cpp	(revision 697)
@@ -45,5 +45,5 @@
 
 const int POLLMS = 1000;				// Period of update, 1 second.
-const char *mydev = "LX200 Basic";			// Name of our device.
+char *mydev;                            // Name of our device.
 
 const char *BASIC_GROUP    = "Main Control";		// Main Group
@@ -151,4 +151,13 @@
 LX200Basic::LX200Basic()
 {
+    mydev = new char[MAXINDIDEVICE];
+
+    char *envDev = getenv("INDIDEV");
+
+    if (envDev != NULL)
+        strncpy(mydev, envDev, MAXINDIDEVICE);
+    else
+        strncpy(mydev, "LX200 Basic", MAXINDIDEVICE);
+
    init_properties();
 
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200fs2.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200fs2.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200fs2.cpp	(revision 697)
@@ -64,5 +64,5 @@
 
    IDLog("Initilizing from LX200 FS2 device...\n");
-   IDLog("Driver Version: 2011-01-02\n");
+   IDLog("Driver Version: 2012-07-22\n");
  
    //enableSimulation(true);  
@@ -151,5 +151,8 @@
   
   if (FirmwareVerNP.np[0].value < 1.19)
-	return getLX200RA(fd, &x); // Version 1.18 and below don't support ACK command
+  {
+	getLX200RA(fd, &x);
+	return getLX200DEC(fd, &x); // Version 1.18 and below don't support ACK command
+  }
   else
 	return check_lx200_connection(fd);
@@ -216,7 +219,5 @@
 void LX200Fs2::getBasicData()
 {
-
-  // process parent first
-   LX200Generic::getBasicData();
+  //LX200Generic::getBasicData()
   // Make sure short
   //checkLX200Format(fd);
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp	(revision 697)
@@ -507,9 +507,9 @@
 
  }
-
+ IEAddTimer (POLLMS, ISPoll, NULL);
 }
 
 void ISGetProperties (const char *dev)
-{ ISInit(); telescope->ISGetProperties(dev); IEAddTimer (POLLMS, ISPoll, NULL);}
+{ ISInit(); telescope->ISGetProperties(dev);}
 void ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
 { ISInit(); telescope->ISNewSwitch(dev, name, states, names, n);}
@@ -555,7 +555,7 @@
    IDLog("INDI Library v%g\n", INDI_LIBV);
    IDLog("initilizaing from generic LX200 device...\n");
-   IDLog("Driver Version: 2008-05-21\n");
+   IDLog("Driver Version: 2012-07-27\n");
  
-   //enableSimulation(true);  
+   //enableSimulation(true);
 }
 
@@ -1750,5 +1750,5 @@
 		mountSim();
 		return;
-        }
+	}
 
 	if ( (err = getLX200RA(fd, &currentRA)) < 0 || (err = getLX200DEC(fd, &currentDEC)) < 0)
@@ -1777,5 +1777,5 @@
         break;
 
-        case IPS_BUSY:
+	case IPS_BUSY:
 	    dx = targetRA - currentRA;
 	    dy = targetDEC - currentDEC;
@@ -1789,6 +1789,6 @@
 	       EquatorialCoordsWNP.s = IPS_OK;
 	       IDSetNumber(&EquatorialCoordsWNP, "Slew is complete, target locked...");
-	       
-	    break;
+		}  
+		break;
 
 	case IPS_OK:
@@ -1801,5 +1801,5 @@
 }
 
-}
+
 // wildi nothing changed in LX200Generic::mountSim
 void LX200Generic::mountSim ()
@@ -2117,4 +2117,5 @@
 	}
 	
+	 tty_disconnect(fd); // Close if already open
 	 if (tty_connect(PortTP.tp[0].text, 9600, 8, 0, 1, &fd) != TTY_OK)
 	 {
Index: /BAORadio/libindi/libindi/drivers/telescope/magellan1.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/magellan1.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/magellan1.cpp	(revision 697)
@@ -98,4 +98,8 @@
 void ISInit()
 {
+  static int isInit=0;
+	
+  if (isInit)
+	  return;
   if (telescope == NULL)
   {
@@ -104,8 +108,11 @@
     telescope->setCurrentDeviceName(mydev);
   }
+ 
+  isInit = 1;
+  IEAddTimer (POLLMS, ISPoll, NULL);
 }
 
 void ISGetProperties (const char *dev)
-{ ISInit(); telescope->ISGetProperties(dev); IEAddTimer (POLLMS, ISPoll, NULL);}
+{ ISInit(); telescope->ISGetProperties(dev);}
 
 void ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
Index: /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp	(revision 696)
+++ /BAORadio/libindi/libindi/drivers/telescope/synscanmount.cpp	(revision 697)
@@ -119,7 +119,4 @@
 void SynscanMount::ISGetProperties (const char *dev)
 {
-    //if (isDebug())
-        IDLog("Enter SynscanMount::ISGetProperties %s\n",dev);
-
     //  First we let our parent class do it's thing
     INDI::Telescope::ISGetProperties(dev);
@@ -147,6 +144,6 @@
         //  this is not a correct echo
         //if (isDebug())
-            IDLog("ReadStatus Echo Fail\n");
-        IDMessage(deviceName(),"Mount Not Responding");
+            IDLog("ReadStatus Echo Fail. %s\n", str);
+        IDMessage(getDeviceName(),"Mount Not Responding");
         return false;
     }
@@ -183,5 +180,5 @@
             ParkSV->s=IPS_OK;
             IDSetSwitch(ParkSV,NULL);
-            IDMessage(deviceName(),"Telescope is Parked.");
+            IDMessage(getDeviceName(),"Telescope is Parked.");
         }
 
@@ -276,5 +273,5 @@
 
     TrackState=SCOPE_PARKING;
-    IDMessage(deviceName(),"Parking Telescope...");
-    return true;
-}
+    IDMessage(getDeviceName(),"Parking Telescope...");
+    return true;
+}
